/*
* CdS sensor.
*/

import processing.gainer.*;

Gainer gainer;

void setup()
{
  size(200, 200);
  colorMode(HSB,100);
  background(0);
  
  gainer = new Gainer(this);
  gainer.beginAnalogInput(); 
}

void draw()
{
  clear();
  
  int bright = gainer.analogInput[0];
  int angle = 0;
  
  for( int i=0; i <= bright; i++){
    int x = width/2 + (int)( i * cos(radians(angle) - bright/10) );
    int y = height/2 + (int)( i * sin(radians(angle) - bright/10) );
    
    fill(99, 10);
    noStroke();
    ellipse( x, y, i, i);
    angle += 20;
  }
  
}

void clear()
{
  fill( 0);
  noStroke();
  rect( 0, 0, width, height);
}
