/*
* PSD sensor.
*/

import processing.gainer.*;

Gainer gainer;

void setup()
{
  size(200, 200);
  colorMode(HSB,99);
  background(0);
  
  gainer = new Gainer(this);
  gainer.beginAnalogInput(); 
}

void draw()
{
  clear();
  
  int distance = (int)( gainer.analogInput[0]);
  
  for( int i=0; i < 100; i++){
    if( (i%10) == (distance%10)){
      fadeToWhite(36);
      color fillColor = percentToHue(distance-i);
      paintEllipse(i, fillColor);
      if(i >= 90){ fadeToWhite(36-4*(i%10));}
    }
  }
}

color percentToHue(int percent)
{
  if( percent < 0){ percent = 100 - percent;}
  if( percent > 99){ percent = percent - 100;}
  return color(percent, 99, 99, 50);
}

void paintEllipse(int distance, color fillColor)
{
  int x = width/2;
  int y = height/2;
  fill(fillColor);
  int r = distance * distance / 66;
  ellipse( x+r, y+r, r, r);
  ellipse( x-r, y+r, r, r);
  ellipse( x+r, y-r, r, r);
  ellipse( x-r, y-r, r, r);
}

void fadeToWhite(int whiteAlpha)
{
  fill( 0, 0, 99, whiteAlpha);
  noStroke();
  rect( 0, 0, width, height);
}

void clear()
{
  fill( 99);
  noStroke();
  rect( 0, 0, width, height);
}
