/*
* Volume.
*/

import processing.gainer.*;

Gainer gainer;

int distance;

void setup()
{
  size(300, 300);
  colorMode(RGB,100);
  background(0);
  
  gainer = new Gainer(this);
  gainer.beginAnalogInput(); 
}

void draw()
{
  clear();
  
  distance = (int)gainer.analogInput[0];
  
  twig( 64, distance/2, width/2, height/2, 30);
  twig( 64, distance/2, width/2, height/2, 90);
  twig( 64, distance/2, width/2, height/2, 150);
  twig( 64, distance/2, width/2, height/2, 210);
  twig( 64, distance/2, width/2, height/2, 270);
  twig( 64, distance/2, width/2, height/2, 330);
}

void clear()
{
  fill( 0);
  noStroke();
  rect( 0, 0, width, height);
}

void twig(int twigLength, int n, int x, int y, int angle){
  stroke( 99);
  if( n <= twigLength ){
    line( x, y, x-n*cos(radians(angle)), y-n*sin(radians(angle)) );
  }else{
    int xx = (int)( x-twigLength*cos(radians(angle)) );
    int yy = (int)( y-twigLength*sin(radians(angle)) );
    line( x, y, xx, yy );
    twig(twigLength/2, n-twigLength, xx, yy, angle);
    twig(twigLength/2, n-twigLength, xx, yy, angle+60);
    twig(twigLength/2, n-twigLength, xx, yy, angle-60);
  }
}
