/*
* Volume.
*/

import processing.gainer.*;

Gainer gainer;

int distance;

void setup()
{
  size(300, 300);
  colorMode(RGB,100);
  background(99);
  
  gainer = new Gainer(this);
  gainer.beginAnalogInput(); 
}

void draw()
{
  clear();
  
  distance = gainer.analogInput[0];
  
  twig(128, distance, width/2, height, 90);
}

void clear()
{
  fill( 99);
  noStroke();
  rect( 0, 0, width, height);
}

void twig(int twigLength, int n, int x, int y, int angle){
  stroke( 0, 80, 0);
  if( n <= twigLength ){
    line( x, y, x-n*cos(radians(angle)), y-n*sin(radians(angle)) );
  }else{
    int xx = (int)( x-twigLength*cos(radians(angle)) );
    int yy = (int)( y-twigLength*sin(radians(angle)) );
    line( x, y, xx, yy );
    twig(twigLength/2, n-twigLength, xx, yy, angle);
    twig(twigLength/2, n-twigLength, xx, yy, angle+90);
    twig(twigLength/2, n-twigLength, xx, yy, angle-90);
  }
}
