/*
* Pyroelectric sensor.
*/

import processing.gainer.*;

Gainer gainer;

void setup()
{
  size(200, 200);
  colorMode(RGB,100);
  background(99);
  
  PFont myFont =loadFont("Arial-BoldMT-18.vlw");
  textFont( myFont,18);
  textAlign( CENTER );
  
  gainer = new Gainer(this);
  gainer.beginDigitalInput(); 
}

void draw()
{
  if(gainer.digitalInput[0]){
    disappear();
  }else{
    appear( width/2, height/2);
  }
}

void appear( int x, int y )
{
  noStroke();
  fill(99, 75, 0);
  
  ellipse( x, y-60, 40, 40);
  ellipse( x-20, y-20, 40, 40);
  ellipse( x+20, y-20, 40, 40);
  rect( x-20, y-40, 40, 110);
  rect( x-40, y-18, 80, 40);
  ellipse( x-31, y+20, 18, 18);
  ellipse( x+31, y+20, 18, 18);
  ellipse( x-11, y+70, 18, 18);
  ellipse( x+11, y+70, 18, 18);
  
  fill(99);
  rect( x-22, y-18, 2, 40);
  rect( x+20, y-18, 2, 40);
  rect( x-1, y+20, 2, 70);
  
  fill(99);
  rect( 0, height/2-10, 200, 18);
  fill(99, 0, 0);
  text( "There is someone!", width/2, height/2+5);
}

void disappear()
{
  fill( 99);
  noStroke();
  rect( 0, 0, width, height);
  
  fill( 0, 0, 99);
  text( "There are no one.", width/2, height/2+5);
}
